#include <fcntl.h>
#include <stdlib.h>
#include <sched.h>
#include <sys/mman.h>
#include <string.h>

#define MY_PRIORITY (49)
#define MAX_SAFE_STACK (8*1024) 

void stack_prefault(void) {

        unsigned char dummy[MAX_SAFE_STACK];

        memset(&dummy, 0, MAX_SAFE_STACK);
        return;
}

int main (void)
{
  int  i, fd, trace_fd;
  char one = '1';
  char zero = '0';
  struct sched_param param;

  /* Declare ourself as a real time task */
  param.sched_priority = MY_PRIORITY;
  if(sched_setscheduler(0, SCHED_FIFO, &param) == -1) 
  {
     perror("sched_setscheduler failed");
     exit(-1);
  }

  /* Lock memory */
  if(mlockall(MCL_CURRENT|MCL_FUTURE) == -1) 
  {
     perror("mlockall failed");
     exit(-2);
  }

  /* Pre-fault our stack */
  stack_prefault();


  /* Open trace activation file */
  if ((trace_fd = open("/sys/kernel/debug/tracing/tracing_on", O_WRONLY)) == -1)
  {
    perror("Can't open tracing file.");
    exit(-3);
  }
  else
	/* Activate tracing */
    if (write(trace_fd, &one, 1) < 0)
    {
      perror("Can't write on tracing file.");
      exit(-4);
    }

  /* Open device file */
  if ((fd = open("/dev/pp", O_WRONLY | O_NDELAY)) == -1)
  {
    perror("Can't open device.");
    exit(-5);
  }
  else
	/* 100 write */
    for (i = 0; i < 100; i++)
    {
	  /* 5ms */
      usleep (5000);
	  /* Write 1 octet to the device */
      if (write(fd, &one, 1) < 0)
      {
	perror("Can't write on device.");
        exit(-6);
      }
    }

  /* Stop tracing */
  if (write(trace_fd, &zero, 1) < 0)
      perror("Can't write on tracing file.");
  close(fd);
  close(trace_fd);

  return 0;
}
