#include <fcntl.h>
#include <stdlib.h>

int main (void)
{
  int  i, fd, trace_fd;
  char one = '1';
  char zero = '0';

  /* Open trace activation file */
  if ((trace_fd = open("/sys/kernel/debug/tracing/tracing_on", O_WRONLY)) == -1)
  {
    perror("Can't open tracing file.");
    exit(-3);
  }
  else
	/* Activate tracing */
    if (write(trace_fd, &one, 1) < 0)
    {
      perror("Can't write on tracing file.");
      exit(-4);
    }
	
  /* Open device file */
  if ((fd = open("/dev/pp", O_WRONLY | O_NDELAY)) == -1)
  {
    perror("Can't open device.");
    exit(-5);
  }
  else
	/* 100 write */
    for (i = 0; i < 100; i++)
    {
	  /* 5ms */
      usleep (5000);
	  /* Write 1 octet to the device */
      if (write(fd, &one, 1) < 0)
      {
	perror("Can't write on device.");
        exit(-6);
      }
    }

  /* Stop tracing */
  if (write(trace_fd, &zero, 1) < 0)
      perror("Can't write on tracing file.");
  close(fd);
  close(trace_fd);

  return 0;
}
